/*************************************************************************
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005-2008 by Kohei Yoshida.
 *    1039 Kingsway Dr., Apex, NC 27502, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SCSOLVER_NUMERIC_QUADFIT_LINESEARCH_HXX_
#define _SCSOLVER_NUMERIC_QUADFIT_LINESEARCH_HXX_

#include "numeric/baselinesearch.hxx"
#include <cstddef>

namespace scsolver {
    class Timer;
}

namespace scsolver { namespace numeric {

class SingleVarFuncObj;

/** 
 * This class implements quadratic fit line search as described in p.280 of
 * Nonlinear Programming Theory and Algorithms, 2nd edition by Banaraa,
 * M.S., Sherali, H.D., and Shetty, C.M. 
 *  
 * The algorithm implemented here has been modified from the original one 
 * described in the above reference. 
 */
class QuadFitLineSearch : public BaseLineSearch
{
public:
    QuadFitLineSearch();
    explicit QuadFitLineSearch(SingleVarFuncObj* pFuncObj);
    virtual ~QuadFitLineSearch();

    virtual double solve();

private:
    size_t m_maxIteration;
};

}}

#endif
